[BACK]Return to rc CVS log [TXT][DIR] Up to [local] / src / etc

Annotation of src/etc/rc, Revision 1.507

1.507   ! rpe         1: #      $OpenBSD: rc,v 1.506 2017/06/30 17:06:03 rpe Exp $
1.1       deraadt     2:
1.450     rpe         3: # System startup script run by init on autoboot or after single-user.
                      4: # Output and error are redirected to console by init, and the console is the
                      5: # controlling terminal.
1.454     rpe         6:
                      7: # Turn off Strict Bourne shell.
                      8: set +o sh
1.1       deraadt     9:
1.131     millert    10: # Subroutines (have to come first).
                     11:
1.456     rpe        12: # Strip in- and whole-line comments from a file.
                     13: # Strip leading and trailing whitespace if IFS is set.
                     14: # Usage: stripcom /path/to/file
1.131     millert    15: stripcom() {
1.456     rpe        16:        local _file=$1 _line
1.131     millert    17:
1.456     rpe        18:        [[ -s $_file ]] || return
                     19:
                     20:        while read _line ; do
                     21:                _line=${_line%%#*}
                     22:                [[ -n $_line ]] && print -r -- "$_line"
                     23:        done <$_file
1.131     millert    24: }
                     25:
1.456     rpe        26: # Update resource limits based on login.conf settings.
                     27: # Usage: update_limit -flag capability
1.265     millert    28: update_limit() {
1.456     rpe        29:        local _flag=$1          # ulimit flag
                     30:        local _cap=$2 _val      # login.conf capability and its value
                     31:        local _suffix
                     32:
1.490     otto       33:        for _suffix in {,-max,-cur}; do
1.456     rpe        34:                _val=$(getcap -f /etc/login.conf -s ${_cap}${_suffix} daemon 2>/dev/null)
                     35:                [[ -n $_val ]] || continue
                     36:                [[ $_val == infinity ]] && _val=unlimited
                     37:
                     38:                case $_suffix in
                     39:                -cur)   ulimit -S $_flag $_val
                     40:                        ;;
                     41:                -max)   ulimit -H $_flag $_val
                     42:                        ;;
                     43:                *)      ulimit $_flag $_val
                     44:                        return
                     45:                        ;;
                     46:                esac
1.265     millert    47:        done
                     48: }
                     49:
1.457     rpe        50: # Apply sysctl.conf(5) settings.
1.265     millert    51: sysctl_conf() {
1.457     rpe        52:        stripcom /etc/sysctl.conf |
                     53:        while read _line; do
                     54:                sysctl "$_line"
1.267     millert    55:
1.457     rpe        56:                case $_line in
1.265     millert    57:                kern.maxproc=*)
1.457     rpe        58:                        update_limit -p maxproc;;
1.265     millert    59:                kern.maxfiles=*)
1.457     rpe        60:                        update_limit -n openfiles;;
1.265     millert    61:                esac
                     62:        done
                     63: }
                     64:
1.457     rpe        65: # Apply mixerctl.conf(5) settings.
1.452     rpe        66: mixerctl_conf() {
1.457     rpe        67:        stripcom /etc/mixerctl.conf |
                     68:        while read _line; do
                     69:                mixerctl -q "$_line" 2>/dev/null
1.265     millert    70:        done
                     71: }
                     72:
1.457     rpe        73: # Apply wsconsctl.conf(5) settings.
1.452     rpe        74: wsconsctl_conf() {
1.457     rpe        75:        [[ -x /sbin/wsconsctl ]] || return
1.267     millert    76:
1.457     rpe        77:        stripcom /etc/wsconsctl.conf |
                     78:        while read _line; do
1.458     rpe        79:                eval "wsconsctl $_line"
1.267     millert    80:        done
                     81: }
                     82:
1.495     rpe        83: # Push the old seed into the kernel, create a future seed  and create a seed
                     84: # file for the boot-loader.
1.452     rpe        85: random_seed() {
1.427     bluhm      86:        dd if=/var/db/host.random of=/dev/random bs=65536 count=1 status=none
                     87:        chmod 600 /var/db/host.random
                     88:        dd if=/dev/random of=/var/db/host.random bs=65536 count=1 status=none
                     89:        dd if=/dev/random of=/etc/random.seed bs=512 count=1 status=none
                     90:        chmod 600 /etc/random.seed
1.312     djm        91: }
                     92:
1.450     rpe        93: # Populate net.inet.(tcp|udp).baddynamic with the contents of /etc/services so
                     94: # as to avoid randomly allocating source ports that correspond to well-known
1.451     rpe        95: # services.
1.459     rpe        96: # Usage: fill_baddynamic tcp|udp
1.452     rpe        97: fill_baddynamic() {
1.390     halex      98:        local _service=$1
1.318     djm        99:        local _sysctl="net.inet.${_service}.baddynamic"
1.459     rpe       100:
1.390     halex     101:        stripcom /etc/services |
                    102:        {
1.459     rpe       103:                _ban=
1.390     halex     104:                while IFS="     /" read _name _port _srv _junk; do
1.459     rpe       105:                        [[ $_srv == $_service ]] || continue
                    106:
                    107:                        _ban="${_ban:+$_ban,}+$_port"
                    108:
1.390     halex     109:                        # Flush before argv gets too long
1.459     rpe       110:                        if ((${#_ban} > 1024)); then
                    111:                                sysctl -q "$_sysctl=$_ban"
                    112:                                _ban=
1.390     halex     113:                        fi
                    114:                done
1.459     rpe       115:                [[ -n $_ban ]] && sysctl -q "$_sysctl=$_ban"
1.390     halex     116:        }
1.318     djm       117: }
                    118:
1.450     rpe       119: # Start daemon using the rc.d daemon control scripts.
1.451     rpe       120: # Usage: start_daemon daemon1 daemon2 daemon3
1.452     rpe       121: start_daemon() {
1.460     rpe       122:        local _daemon
                    123:
                    124:        for _daemon; do
                    125:                eval "_do=\${${_daemon}_flags}"
                    126:                [[ $_do != NO ]] && /etc/rc.d/${_daemon} start
1.353     robert    127:        done
                    128: }
                    129:
1.469     tim       130: # Generate keys for isakmpd, iked and sshd if they don't exist yet.
1.452     rpe       131: make_keys() {
1.460     rpe       132:        local _isakmpd_key=/etc/isakmpd/private/local.key
                    133:        local _isakmpd_pub=/etc/isakmpd/local.pub
                    134:        local _iked_key=/etc/iked/private/local.key
                    135:        local _iked_pub=/etc/iked/local.pub
                    136:
                    137:        if [[ ! -f $_isakmpd_key ]]; then
                    138:                echo -n "openssl: generating isakmpd/iked RSA keys... "
                    139:                if openssl genrsa -out $_isakmpd_key 2048 >/dev/null 2>&1 &&
                    140:                        chmod 600 $_isakmpd_key &&
                    141:                        openssl rsa -out $_isakmpd_pub -in $_isakmpd_key \
                    142:                            -pubout >/dev/null 2>&1; then
1.373     deraadt   143:                        echo done.
                    144:                else
                    145:                        echo failed.
                    146:                fi
                    147:        fi
                    148:
1.460     rpe       149:        if [[ ! -f $_iked_key ]]; then
1.373     deraadt   150:                # Just copy the generated isakmpd key
1.460     rpe       151:                cp $_isakmpd_key $_iked_key
                    152:                chmod 600 $_iked_key
                    153:                cp $_isakmpd_pub $_iked_pub
1.373     deraadt   154:        fi
                    155:
                    156:        ssh-keygen -A
                    157: }
                    158:
1.483     rpe       159: # Re-link libraries, placing the objects in a random order.
1.481     rpe       160: reorder_libs() {
1.498     tb        161:        local _dkdev _l _liba _libas _mp _tmpdir _remount=false _error=false
                    162:
                    163:        [[ $library_aslr == NO ]] && return
                    164:
                    165:        _dkdev=$(df /usr/lib | sed '1d;s/ .*//')
                    166:        _mp=$(mount | grep "^$_dkdev")
1.481     rpe       167:
1.484     rpe       168:        # Skip if /usr/lib is on a nfs mounted filesystem.
                    169:        [[ $_mp == *' type nfs '* ]] && return
                    170:
1.481     rpe       171:        echo -n 'reordering libraries:'
1.475     deraadt   172:
1.481     rpe       173:        # Only choose the latest version of the libraries.
1.496     deraadt   174:        for _liba in /usr/lib/libc.so.*.a /usr/lib/libcrypto.so.*.a; do
1.476     rpe       175:                _liba=$(ls ${_liba%%.[0-9]*}*.a | sort -V | tail -1)
1.475     deraadt   176:                for _l in $_libas; do
                    177:                        [[ $_l == $_liba ]] && continue 2
                    178:                done
                    179:                _libas="$_libas $_liba"
                    180:        done
                    181:
1.481     rpe       182:        # Remount read-write, if /usr/lib is on a read-only ffs filesystem.
                    183:        if [[ $_mp == *' type ffs '*'read-only'* ]]; then
                    184:                if mount -u -w $_dkdev; then
                    185:                        _remount=true
                    186:                else
                    187:                        echo ' failed.'
                    188:                        return
                    189:                fi
                    190:        fi
                    191:
1.475     deraadt   192:        for _liba in $_libas; do
1.485     rpe       193:                _tmpdir=$(mktemp -dq /tmp/_librebuild.XXXXXXXXXXXX) && (
1.475     deraadt   194:                        set -o errexit
                    195:                        _lib=${_liba#/usr/lib/}
                    196:                        _lib=${_lib%.a}
                    197:                        cd $_tmpdir
                    198:                        ar x ${_liba}
                    199:                        cc -shared -o $_lib $(ls *.so | sort -R) $(cat .ldadd)
                    200:                        [[ -s $_lib ]] && file $_lib | fgrep -q 'shared object'
                    201:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir awk 'BEGIN {exit 0}'
1.500     deraadt   202:                        LD_BIND_NOW=1 LD_LIBRARY_PATH=$_tmpdir openssl \
                    203:                            x509 -in /etc/ssl/cert.pem -out /dev/null
1.480     rpe       204:                        install -F -S -o root -g bin -m 0444 $_lib /usr/lib/$_lib
1.485     rpe       205:                ) || { _error=true; break; }
1.475     deraadt   206:        done
1.481     rpe       207:
1.485     rpe       208:        rm -rf /tmp/_librebuild.*
                    209:
1.481     rpe       210:        # Restore previous mount state if it was changed.
                    211:        if $_remount; then
1.485     rpe       212:                mount -u -r $_dkdev || _error=true
1.481     rpe       213:        fi
1.482     deraadt   214:
1.485     rpe       215:        if $_error; then
                    216:                echo ' failed.'
                    217:        else
                    218:                echo ' done.'
                    219:        fi
1.475     deraadt   220: }
                    221:
1.502     rpe       222: # Re-link the kernel, placing the objects in a random order.
                    223: # Replace current with relinked kernel and inform root about it.
1.507   ! rpe       224: reorder_kernel() (
1.506     rpe       225:        local _dkdev=$(df /usr/share | sed '1d;s/ .*//')
                    226:
                    227:        # Skip if /usr/share is on a nfs mounted filesystem.
                    228:        [[ $(mount | grep "^$_dkdev") == *" type nfs "* ]] && return
                    229:
                    230:        _compile=/usr/share/compile
1.502     rpe       231:        _kernel=$(sysctl -n kern.osversion)
                    232:        _kernel=${_kernel%#*}
1.507   ! rpe       233:        _log=$_compile/$_kernel/relink.log
1.504     deraadt   234:        _sha256=/var/db/kernel.SHA256
1.502     rpe       235:
1.507   ! rpe       236:        mkdir -m 700 -p $_compile/$_kernel
        !           237:        exec 1>$_log
        !           238:        exec 2>&1
        !           239:
        !           240:        trap 'trap - EXIT; logger -st /etc/rc \
        !           241:                "kernel relinking failed; see $_log" >>/dev/console 2>&1' ERR
        !           242:        trap 'logger -t /etc/rc "kernel relinking done"' EXIT
        !           243:        set -e
        !           244:
1.506     rpe       245:        if [[ -f $_compile.tgz ]]; then
1.507   ! rpe       246:                rm -rf $_compile/$_kernel/*
        !           247:                exec 1>$_log
1.506     rpe       248:                tar -C $_compile -xzf $_compile.tgz $_kernel
                    249:                rm -f $_compile.tgz
1.502     rpe       250:        fi
                    251:
1.507   ! rpe       252:        sha256 -C $_sha256 /bsd
1.502     rpe       253:
1.506     rpe       254:        cd $_compile/$_kernel
                    255:        make newbsd
                    256:        make newinstall
                    257:
                    258:        echo "\nKernel has been relinked and is active on next reboot.\n"
                    259:        cat $_sha256
1.507   ! rpe       260: )
1.502     rpe       261:
1.483     rpe       262: # Run rc.* script and email output to root.
                    263: # Usage: run_upgrade_script firsttime|sysmerge
1.477     ajacouto  264: run_upgrade_script() {
                    265:        local _suffix=$1
1.491     rpe       266:
1.477     ajacouto  267:        [[ -n $_suffix ]] || return 1
1.491     rpe       268:
1.477     ajacouto  269:        if [[ -f /etc/rc.$_suffix ]]; then
                    270:                mv /etc/rc.$_suffix /etc/rc.$_suffix.run
                    271:                . /etc/rc.$_suffix.run 2>&1 | tee /dev/tty |
                    272:                        mail -Es "$(hostname) rc.$_suffix output" root >/dev/null
                    273:        fi
                    274:        rm -f /etc/rc.$_suffix.run
                    275: }
                    276:
1.462     rpe       277: # Check filesystems, optionally by using a fsck(8) flag.
                    278: # Usage: do_fsck [-flag]
1.452     rpe       279: do_fsck() {
1.462     rpe       280:        fsck -p "$@"
1.429     claudio   281:        case $? in
1.462     rpe       282:        0)      ;;
                    283:        2)      exit 1
1.429     claudio   284:                ;;
1.462     rpe       285:        4)      echo "Rebooting..."
1.429     claudio   286:                reboot
                    287:                echo "Reboot failed; help!"
                    288:                exit 1
                    289:                ;;
1.462     rpe       290:        8)      echo "Automatic file system check failed; help!"
1.429     claudio   291:                exit 1
                    292:                ;;
1.462     rpe       293:        12)     echo "Boot interrupted."
1.429     claudio   294:                exit 1
                    295:                ;;
1.462     rpe       296:        130)    # Interrupt before catcher installed.
1.429     claudio   297:                exit 1
                    298:                ;;
1.462     rpe       299:        *)      echo "Unknown error; help!"
1.429     claudio   300:                exit 1
                    301:                ;;
                    302:        esac
                    303: }
                    304:
1.450     rpe       305: # End subroutines.
1.131     millert   306:
1.1       deraadt   307: stty status '^T'
                    308:
1.450     rpe       309: # Set shell to ignore SIGINT (2), but not children; shell catches SIGQUIT (3)
                    310: # and returns to single user after fsck.
1.1       deraadt   311: trap : 2
1.450     rpe       312: trap : 3       # Shouldn't be needed.
1.1       deraadt   313:
1.463     rpe       314: export HOME=/
                    315: export INRC=1
                    316: export PATH=/sbin:/bin:/usr/sbin:/usr/bin
1.395     deraadt   317:
1.450     rpe       318: # Must set the domainname before rc.conf, so YP startup choices can be made.
1.463     rpe       319: if [[ -s /etc/defaultdomain ]]; then
                    320:        domainname "$(stripcom /etc/defaultdomain)"
1.395     deraadt   321: fi
1.108     deraadt   322:
1.495     rpe       323: # Get local functions from rc.subr to load rc.conf into scope.
1.428     robert    324: FUNCS_ONLY=1 . /etc/rc.d/rc.subr
                    325: _rc_parse_conf
1.343     robert    326:
1.495     rpe       327: # If executed with the 'shutdown' parameter by the halt, reboot or shutdown:
                    328: # - update seed files
                    329: # - execute the rc.d scripts specified by $pkg_scripts in reverse order
                    330: # - bring carp interfaces down gracefully
1.463     rpe       331: if [[ $1 == shutdown ]]; then
1.437     bluhm     332:        if echo 2>/dev/null >>/var/db/host.random || \
                    333:            echo 2>/dev/null >>/etc/random.seed; then
                    334:                random_seed
                    335:        else
                    336:                echo warning: cannot write random seed to disk
                    337:        fi
1.416     rpe       338:
1.469     tim       339:        # If we are in secure level 0, assume single user mode.
1.463     rpe       340:        if (($(sysctl -n kern.securelevel) == 0)); then
                    341:                echo 'single user: not running shutdown scripts'
                    342:        else
1.421     schwarze  343:                pkg_scripts=${pkg_scripts%%*( )}
1.463     rpe       344:                if [[ -n $pkg_scripts ]]; then
1.413     deraadt   345:                        echo -n 'stopping package daemons:'
1.463     rpe       346:                        while [[ -n $pkg_scripts ]]; do
                    347:                                _d=${pkg_scripts##* }
                    348:                                pkg_scripts=${pkg_scripts%%*( )$_d}
                    349:                                [[ -x /etc/rc.d/$_d ]] && /etc/rc.d/$_d stop
1.413     deraadt   350:                        done
                    351:                        echo '.'
                    352:                fi
                    353:
1.463     rpe       354:                [[ -f /etc/rc.shutdown ]] && sh /etc/rc.shutdown
1.413     deraadt   355:        fi
1.240     mcbride   356:
1.463     rpe       357:        ifconfig | while read _if _junk; do
1.474     rpe       358:                [[ $_if == carp+([0-9]): ]] && ifconfig ${_if%:} down
1.413     deraadt   359:        done
1.246     mcbride   360:
1.108     deraadt   361:        exit 0
1.1       deraadt   362: fi
1.98      jakob     363:
1.482     deraadt   364: # Add swap block-devices.
1.172     miod      365: swapctl -A -t blk
1.170     deraadt   366:
1.495     rpe       367: # Run filesystem check unless a /fastboot file exists.
1.463     rpe       368: if [[ -e /fastboot ]]; then
1.1       deraadt   369:        echo "Fast boot: skipping disk checks."
1.463     rpe       370: elif [[ $1 == autoboot ]]; then
1.1       deraadt   371:        echo "Automatic boot in progress: starting file system checks."
1.429     claudio   372:        do_fsck
1.1       deraadt   373: fi
                    374:
1.495     rpe       375: # From now on, allow user to interrupt (^C) the boot process.
1.1       deraadt   376: trap "echo 'Boot interrupted.'; exit 1" 3
                    377:
1.495     rpe       378: # Unmount all filesystems except root.
1.1       deraadt   379: umount -a >/dev/null 2>&1
1.495     rpe       380:
                    381: # Mount all filesystems except those of type NFS and VND.
1.303     grunk     382: mount -a -t nonfs,vnd
1.177     deraadt   383:
1.495     rpe       384: # Re-mount the root filesystem read/writeable. (root on nfs requires this,
                    385: # others aren't hurt.)
                    386: mount -uw /
1.499     deraadt   387: chmod og-rwx /bsd
1.503     deraadt   388: ln -fh /bsd /bsd.booted
1.495     rpe       389:
                    390: rm -f /fastboot
                    391:
1.505     tedu      392: # Set flags on ttys.
1.1       deraadt   393: echo 'setting tty flags'
                    394: ttyflags -a
1.77      angelos   395:
1.464     rpe       396: # Set keyboard encoding.
                    397: if [[ -x /sbin/kbd && -s /etc/kbdtype ]]; then
                    398:        kbd "$(cat /etc/kbdtype)"
1.252     mcbride   399: fi
                    400:
1.279     deraadt   401: wsconsctl_conf
                    402:
1.464     rpe       403: # Set initial temporary pf rule set.
                    404: if [[ $pf != NO ]]; then
1.211     mcbride   405:        RULES="block all"
1.228     henning   406:        RULES="$RULES\npass on lo0"
1.447     krw       407:        RULES="$RULES\npass in proto tcp from any to any port ssh keep state"
                    408:        RULES="$RULES\npass out proto { tcp, udp } from any to any port domain keep state"
1.215     camield   409:        RULES="$RULES\npass out inet proto icmp all icmp-type echoreq keep state"
1.420     claudio   410:        RULES="$RULES\npass out inet proto udp from any port bootpc to any port bootps"
                    411:        RULES="$RULES\npass in inet proto udp from any port bootps to any port bootpc"
1.257     grange    412:        if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.258     itojun    413:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type neighbrsol"
                    414:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type neighbradv"
1.257     grange    415:                RULES="$RULES\npass out inet6 proto icmp6 all icmp6-type routersol"
                    416:                RULES="$RULES\npass in inet6 proto icmp6 all icmp6-type routeradv"
1.420     claudio   417:                RULES="$RULES\npass out inet6 proto udp from any port dhcpv6-client to any port dhcpv6-server"
                    418:                RULES="$RULES\npass in inet6 proto udp from any port dhcpv6-server to any port dhcpv6-client"
1.257     grange    419:        fi
1.424     henning   420:        RULES="$RULES\npass in proto carp keep state (no-sync)"
                    421:        RULES="$RULES\npass out proto carp !received-on any keep state (no-sync)"
1.474     rpe       422:        if [[ $(sysctl vfs.mounts.nfs 2>/dev/null) == *[1-9]* ]]; then
1.450     rpe       423:                # Don't kill NFS.
1.324     henning   424:                RULES="set reassemble yes no-df\n$RULES"
1.447     krw       425:                RULES="$RULES\npass in proto { tcp, udp } from any port { sunrpc, nfsd } to any"
                    426:                RULES="$RULES\npass out proto { tcp, udp } from any to any port { sunrpc, nfsd } !received-on any"
1.474     rpe       427:        fi
1.464     rpe       428:        print -- "$RULES" | pfctl -f -
1.269     dhartmei  429:        pfctl -e
1.176     kjell     430: fi
1.318     djm       431:
                    432: fill_baddynamic udp
                    433: fill_baddynamic tcp
1.176     kjell     434:
1.267     millert   435: sysctl_conf
1.260     jsg       436:
1.501     florian   437: start_daemon slaacd >/dev/null 2>&1
                    438:
1.1       deraadt   439: echo 'starting network'
1.464     rpe       440:
                    441: # Set carp interlock by increasing the demotion counter.
                    442: # Prevents carp from preempting until the system is booted.
1.289     henning   443: ifconfig -g carp carpdemote 128
1.464     rpe       444:
1.439     ajacouto  445: sh /etc/netstart
1.464     rpe       446:
1.495     rpe       447: # Any write triggers a rekey.
                    448: dmesg >/dev/random
1.176     kjell     449:
1.450     rpe       450: # Load pf rules and bring up pfsync interface.
1.464     rpe       451: if [[ $pf != NO ]]; then
                    452:        if [[ -f /etc/pf.conf ]]; then
1.449     ajacouto  453:                pfctl -f /etc/pf.conf
1.309     mpf       454:        fi
1.464     rpe       455:        if [[ -f /etc/hostname.pfsync0 ]]; then
1.435     deraadt   456:                sh /etc/netstart pfsync0
1.367     deraadt   457:        fi
1.176     kjell     458: fi
1.1       deraadt   459:
1.278     otto      460: mount -s /usr >/dev/null 2>&1
                    461: mount -s /var >/dev/null 2>&1
1.180     deraadt   462:
1.389     deraadt   463: random_seed
1.475     deraadt   464:
1.481     rpe       465: reorder_libs
1.29      deraadt   466:
1.450     rpe       467: # Clean up left-over files.
1.492     jca       468: rm -f /etc/nologin /var/spool/lock/LCK.*
1.247     henning   469: (cd /var/run && { rm -rf -- *; install -c -m 664 -g utmp /dev/null utmp; })
1.196     beck      470: (cd /var/authpf && rm -rf -- *)
1.96      alex      471:
1.495     rpe       472: # Save a copy of the boot messages.
                    473: dmesg >/var/run/dmesg.boot
1.55      deraadt   474:
1.373     deraadt   475: make_keys
                    476:
1.379     deraadt   477: echo -n 'starting early daemons:'
1.501     florian   478: start_daemon syslogd ldattach pflogd nsd rebound unbound ntpd
1.429     claudio   479: start_daemon iscsid isakmpd iked sasyncd ldapd npppd
1.353     robert    480: echo '.'
1.280     hshoexer  481:
1.450     rpe       482: # Load IPsec rules.
1.464     rpe       483: if [[ $ipsec != NO && -f /etc/ipsec.conf ]]; then
                    484:        ipsecctl -f /etc/ipsec.conf
1.40      provos    485: fi
1.1       deraadt   486:
1.379     deraadt   487: echo -n 'starting RPC daemons:'
1.399     dlg       488: start_daemon portmap ypldap
1.466     deraadt   489: rm -f /var/run/ypbind.lock
1.464     rpe       490: if [[ -n $(domainname) ]]; then
1.470     deraadt   491:        start_daemon ypserv ypbind
1.376     deraadt   492: fi
1.399     dlg       493: start_daemon mountd nfsd lockd statd amd
1.1       deraadt   494: echo '.'
1.58      deraadt   495:
1.464     rpe       496: # Check and mount remaining file systems and enable additional swap.
1.278     otto      497: mount -a
1.172     miod      498: swapctl -A -t noblk
1.429     claudio   499: do_fsck -N
                    500: mount -a -N
1.1       deraadt   501:
1.450     rpe       502: # /var/crash should be a directory or a symbolic link to the crash directory
                    503: # if core dumps are to be saved.
1.464     rpe       504: if [[ -d /var/crash ]]; then
                    505:        savecore $savecore_flags /var/crash
1.487     rpe       506: fi
                    507:
                    508: # Store ACPI tables in /var/db/acpi to be used by sendbug(1).
                    509: if [[ -x /usr/sbin/acpidump ]]; then
                    510:        acpidump -o /var/db/acpi/
1.90      art       511: fi
                    512:
1.464     rpe       513: if [[ $check_quotas == YES ]]; then
1.41      downsj    514:        echo -n 'checking quotas:'
                    515:        quotacheck -a
                    516:        echo ' done.'
                    517:        quotaon -a
                    518: fi
1.1       deraadt   519:
1.464     rpe       520: # Build kvm(3) and /dev databases.
                    521: kvm_mkdb
1.1       deraadt   522: dev_mkdb
1.464     rpe       523:
                    524: # Set proper permission for the tty device files.
1.101     deraadt   525: chmod 666 /dev/tty[pqrstuvwxyzPQRST]*
1.226     millert   526: chown root:wheel /dev/tty[pqrstuvwxyzPQRST]*
1.1       deraadt   527:
1.495     rpe       528: # Check for the password temp/lock file.
1.467     rpe       529: if [[ -f /etc/ptmp ]]; then
1.1       deraadt   530:        logger -s -p auth.err \
1.376     deraadt   531:            'password file may be incorrect -- /etc/ptmp exists'
1.32      deraadt   532: fi
                    533:
1.49      millert   534: echo clearing /tmp
                    535:
1.450     rpe       536: # Prune quickly with one rm, then use find to clean up /tmp/[lqv]*
                    537: # (not needed with mfs /tmp, but doesn't hurt there...).
1.444     deraadt   538: (cd /tmp && rm -rf [a-km-pr-uw-zA-Z]*)
1.339     sthen     539: (cd /tmp &&
1.443     millert   540:     find . -maxdepth 1 ! -name . ! -name lost+found ! -name quota.user \
1.444     deraadt   541:        ! -name quota.group ! -name vi.recover -execdir rm -rf -- {} \;)
1.373     deraadt   542:
1.462     rpe       543: # Create Unix sockets directories for X if needed and make sure they have
                    544: # correct permissions.
                    545: [[ -d /usr/X11R6/lib ]] && mkdir -m 1777 /tmp/.{X11,ICE}-unix
1.203     hugh      546:
1.467     rpe       547: [[ -f /etc/rc.securelevel ]] && sh /etc/rc.securelevel
                    548:
1.450     rpe       549: # rc.securelevel did not specifically set -1 or 2, so select the default: 1.
1.467     rpe       550: (($(sysctl -n kern.securelevel) == 0)) && sysctl kern.securelevel=1
                    551:
1.1       deraadt   552:
1.450     rpe       553: # Patch /etc/motd.
1.467     rpe       554: if [[ ! -f /etc/motd ]]; then
1.34      deraadt   555:        install -c -o root -g wheel -m 664 /dev/null /etc/motd
                    556: fi
1.467     rpe       557: if T=$(mktemp /tmp/_motd.XXXXXXXXXX); then
1.451     rpe       558:        sysctl -n kern.version | sed 1q >$T
1.494     schwarze  559:        sed -n '/^$/,$p' </etc/motd >>$T
1.102     millert   560:        cmp -s $T /etc/motd || cp $T /etc/motd
                    561:        rm -f $T
                    562: fi
1.34      deraadt   563:
1.467     rpe       564: if [[ $accounting == YES ]]; then
                    565:        [[ ! -f /var/account/acct ]] && touch /var/account/acct
                    566:        echo 'turning on accounting'
                    567:        accton /var/account/acct
1.1       deraadt   568: fi
                    569:
1.467     rpe       570: if [[ -x /sbin/ldconfig ]]; then
1.115     deraadt   571:        echo 'creating runtime link editor directory cache.'
1.471     rpe       572:        [[ -d /usr/local/lib ]] && shlib_dirs="/usr/local/lib $shlib_dirs"
1.467     rpe       573:        [[ -d /usr/X11R6/lib ]] && shlib_dirs="/usr/X11R6/lib $shlib_dirs"
1.115     deraadt   574:        ldconfig $shlib_dirs
1.231     millert   575: fi
                    576:
1.451     rpe       577: echo 'preserving editor files.'; /usr/libexec/vi.recover
1.244     markus    578:
1.477     ajacouto  579: # If rc.sysmerge exists, run it just once, and make sure it is deleted.
                    580: run_upgrade_script sysmerge
                    581:
1.353     robert    582: echo -n 'starting network daemons:'
1.489     reyk      583: start_daemon ldomd sshd switchd snmpd ldpd ripd ospfd ospf6d bgpd ifstated
1.465     renato    584: start_daemon relayd dhcpd dhcrelay mrouted dvmrpd radiusd eigrpd
1.127     itojun    585:
                    586: if ifconfig lo0 inet6 >/dev/null 2>&1; then
1.467     rpe       587:        if (($(sysctl -n net.inet6.ip6.forwarding) == 1)); then
1.376     deraadt   588:                start_daemon route6d rtadvd
1.127     itojun    589:        fi
1.281     reyk      590: fi
                    591:
1.442     matthieu  592: start_daemon hostapd lpd smtpd slowcgi httpd ftpd
1.461     sthen     593: start_daemon ftpproxy ftpproxy6 tftpd tftpproxy identd inetd rarpd bootparamd
1.488     reyk      594: start_daemon rbootd mopd vmd spamd spamlogd sndiod
1.377     robert    595: echo '.'
1.335     deraadt   596:
1.450     rpe       597: # If rc.firsttime exists, run it just once, and make sure it is deleted.
1.477     ajacouto  598: run_upgrade_script firsttime
1.352     ajacouto  599:
1.450     rpe       600: # Run rc.d(8) scripts from packages.
1.467     rpe       601: if [[ -n $pkg_scripts ]]; then
1.352     ajacouto  602:        echo -n 'starting package daemons:'
1.467     rpe       603:        for _daemon in $pkg_scripts; do
                    604:                if [[ -x /etc/rc.d/$_daemon ]]; then
                    605:                        start_daemon $_daemon
1.410     espie     606:                else
1.467     rpe       607:                        echo -n " ${_daemon}(absent)"
1.410     espie     608:                fi
1.352     ajacouto  609:        done
                    610:        echo '.'
                    611: fi
1.17      deraadt   612:
1.467     rpe       613: [[ -f /etc/rc.local ]] && sh /etc/rc.local
1.73      millert   614:
1.495     rpe       615: # Disable carp interlock.
                    616: ifconfig -g carp -carpdemote 128
1.286     mcbride   617:
1.379     deraadt   618: mixerctl_conf
1.467     rpe       619:
1.379     deraadt   620: echo -n 'starting local daemons:'
1.493     matthieu  621: start_daemon apmd sensorsd hotplugd watchdogd cron wsmoused xenodm
1.73      millert   622: echo '.'
1.502     rpe       623:
1.507   ! rpe       624: reorder_kernel &
1.1       deraadt   625:
                    626: date
                    627: exit 0